import { PrintProperty } from "./PrintProperty";
import { BindingType } from "./constants";
import { PrintUtil } from "./PrintUtil";
export class Binding extends PrintProperty {
    constructor(node) {
        super(node);
        this._type = BindingType.Data;
        this._path = PrintUtil.singleChildText(node);
    }
    ;
    get constantValue() {
        // Constants are of the form propName[c], where c is the constant
        let w = null;
        if (this.hasConstant) {
            let left = this.path.indexOf("[");
            let right = this.path.indexOf("]");
            w = this.path.substr(left + 1, right - left - 1);
        }
        return w;
    }
    get hasAction() {
        return (this.path.indexOf("catavolt:action") > -1);
    }
    get hasConstant() {
        // Constants are of the form propName[c], where c is the constant
        let left = this.path.indexOf("[");
        let right = this.path.indexOf("]");
        return (left > -1 && right > -1 && (right - left > 0));
    }
    get path() {
        return this._path;
    }
    get propertyName() {
        let w = null;
        if (this.hasConstant) {
            // Constants are of the form propName[c], where c is the constant
            // The binding still refrences a property name.
            w = this.path.substr(0, this.path.indexOf("["));
        }
        else if (this.hasAction) {
            // No property for an action
        }
        else {
            w = this.path;
        }
        return w;
    }
    get type() {
        return this._type;
    }
}
