import { Component } from "./Component";
import { ResizeMode } from "./constants";
import { Edges } from "./Edges";
import { PrintUtil } from "./PrintUtil";
import { AspectMode, XML_ASPECT_MODE, XML_CAP_INSETS, XML_ENABLED_IN_READ_MODE, XML_RESIZE_MODE, XML_URL } from "./constants";
export class Button extends Component {
    constructor(parentContainer, node) {
        super(parentContainer, node);
        PrintUtil.ifChild(this.nodeChildDict[XML_ASPECT_MODE], (n) => {
            this._aspectMode = PrintUtil.enumValue(n, AspectMode);
        });
        PrintUtil.ifChild(this.nodeChildDict[XML_CAP_INSETS], (n) => {
            this._capInsets = new Edges(node);
        });
        PrintUtil.ifChild(this.nodeChildDict[XML_RESIZE_MODE], (n) => {
            this._resizeMode = PrintUtil.enumValue(n, ResizeMode);
        });
        PrintUtil.ifChild(this.nodeChildDict[XML_URL], (n) => {
            this._urlString = PrintUtil.singleChildText(n);
        });
        PrintUtil.ifChild(this.nodeChildDict[XML_ENABLED_IN_READ_MODE], (n) => {
            this._enabledInReadMode = PrintUtil.singleChildBoolean(n);
        });
    }
    get aspectMode() {
        return this._aspectMode;
    }
    get capInsets() {
        return this._capInsets;
    }
    get resizeMode() {
        return this._resizeMode;
    }
    get urlString() {
        return this._urlString;
    }
    get enableInReadMode() {
        return this._enabledInReadMode;
    }
}
