import { Component } from "./Component";
import { XML_UNCHECKED_COLOR } from "./constants";
import { Color } from "./Color";
import { PrintUtil } from "./PrintUtil";
import { XML_CHECKED_COLOR, XML_ENTRY_SEQ, XML_LINE_COLOR, XML_LINE_WIDTH, XML_RADIO_GROUP } from "./constants";
export class Checkbox extends Component {
    constructor(parentContainer, node) {
        super(parentContainer, node);
        PrintUtil.ifChild(this.nodeChildDict[XML_CHECKED_COLOR], (n) => {
            this._checkedColor = new Color(n);
        });
        PrintUtil.ifChild(this.nodeChildDict[XML_ENTRY_SEQ], (n) => {
            this._entrySeq = PrintUtil.singleChildInt(n);
        });
        PrintUtil.ifChild(this.nodeChildDict[XML_LINE_COLOR], (n) => {
            this._lineColor = new Color(n);
        });
        PrintUtil.ifChild(this.nodeChildDict[XML_LINE_WIDTH], (n) => {
            this._lineWidth = PrintUtil.singleChildFloat(n);
        });
        PrintUtil.ifChild(this.nodeChildDict[XML_RADIO_GROUP], (n) => {
            this._radioGroup = PrintUtil.singleChildText(n);
        });
        PrintUtil.ifChild(this.nodeChildDict[XML_UNCHECKED_COLOR], (n) => {
            this._uncheckedColor = new Color(n);
        });
    }
    get checkedColor() {
        return this._checkedColor;
    }
    get entrySeq() {
        return this._entrySeq;
    }
    get lineColor() {
        return this._lineColor;
    }
    get lineWidth() {
        return this._lineWidth;
    }
    get radioGroup() {
        return this._radioGroup;
    }
    get uncheckedColor() {
        return this._uncheckedColor;
    }
}
