import { Spec } from "./Spec";
import { XML_RED } from "./constants";
import { PrintUtil } from "./PrintUtil";
import { XML_ALPHA, XML_BLUE, XML_GREEN } from "./constants";
export class Color extends Spec {
    static WHITE() {
        let c = new Color(null);
        c._red = 255;
        c._green = 255;
        c._blue = 255;
        c._alpha = 255;
        return c;
    }
    static BLACK() {
        let c = new Color(null);
        c._red = 0;
        c._green = 0;
        c._blue = 0;
        c._alpha = 255;
        return c;
    }
    constructor(node, red, green, blue, alpha) {
        super(node);
        PrintUtil.ifChild(this.nodeChildDict[XML_RED], (n) => {
            this._red = PrintUtil.singleChildInt(n);
        });
        PrintUtil.ifChild(this.nodeChildDict[XML_BLUE], (n) => {
            this._blue = PrintUtil.singleChildInt(n);
        });
        PrintUtil.ifChild(this.nodeChildDict[XML_GREEN], (n) => {
            this._green = PrintUtil.singleChildInt(n);
        });
        PrintUtil.ifChild(this.nodeChildDict[XML_ALPHA], (n) => {
            this._alpha = PrintUtil.singleChildFloat(n);
        });
        if (red !== undefined) {
            this._red = red;
        }
        if (green !== undefined) {
            this._green = green;
        }
        if (blue !== undefined) {
            this._blue = blue;
        }
        if (alpha !== undefined) {
            this._alpha = alpha;
        }
    }
    get alpha() {
        return this._alpha;
    }
    get red() {
        return this._red;
    }
    get green() {
        return this._green;
    }
    get blue() {
        return this._blue;
    }
}
