import { XML_PADDING } from "./constants";
import { Spec } from "./Spec";
import { Binding } from "./Binding";
import { Color } from "./Color";
import { Layout } from "./Layout";
import { Edges } from "./Edges";
import { PrintUtil } from "./PrintUtil";
import { XML_BACKGROUND_COLOR, XML_BINDING, XML_ID, XML_LAYOUT } from "./constants";
/**
 * *********************************
 */
var GenID = 1;
export class Component extends Spec {
    constructor(parentContainer, node, overrideLayout) {
        super(node);
        this._parentContainer = parentContainer;
        if (node) {
            PrintUtil.ifChild(this.nodeChildDict[XML_BACKGROUND_COLOR], (n) => {
                this._backgroundColor = new Color(n);
            });
            PrintUtil.ifChild(this.nodeChildDict[XML_BINDING], (n) => {
                this._binding = new Binding(n);
            });
            PrintUtil.ifChild(this.nodeChildDict[XML_ID], (n) => {
                this._id = PrintUtil.singleChildText(n);
            });
            PrintUtil.ifChild(this.nodeChildDict[XML_LAYOUT], (n) => {
                this._layout = new Layout(n);
            });
            PrintUtil.ifChild(this.nodeChildDict[XML_PADDING], (n) => {
                this._padding = new Edges(n);
            });
            if (!this.id) {
                this._id = "GenID-" + GenID++;
            }
        }
    }
    initComponentWith(overrideLayout) {
        if (overrideLayout) {
            this._layout = overrideLayout;
        }
        if (!this.id) {
            this._id = "Generated-" + GenID++;
        }
    }
    get backgroundColor() {
        return this._backgroundColor;
    }
    get binding() {
        return this._binding;
    }
    get id() {
        return this._id;
    }
    get layout() {
        return this._layout;
    }
    get padding() {
        return this._padding;
    }
    get actualHeights() {
        return this._actualHeights;
    }
    get actualWidths() {
        return this._actualWidths;
    }
    get actualX() {
        return this._actualX;
    }
    get actualY() {
        return this._actualY;
    }
    get height() {
        return this._height;
    }
    get parentContainer() {
        return this._parentContainer;
    }
    get textAttributes() {
        return this._textAttributes;
    }
    get width() {
        return this._width;
    }
    get x() {
        return this._x;
    }
    get y() {
        return this._y;
    }
}
