import { Spec } from "./Spec";
import { XML_TOP } from "./constants";
import { PrintUtil } from "./PrintUtil";
import { XML_BOTTOM, XML_LEFT, XML_RIGHT } from "./constants";
export class Edges extends Spec {
    constructor(node) {
        super(node);
        if (node) {
            PrintUtil.ifChild(this.nodeChildDict[XML_TOP], (n) => {
                this._top = PrintUtil.singleChildFloat(n);
            });
            PrintUtil.ifChild(this.nodeChildDict[XML_LEFT], (n) => {
                this._left = PrintUtil.singleChildFloat(n);
            });
            PrintUtil.ifChild(this.nodeChildDict[XML_BOTTOM], (n) => {
                this._bottom = PrintUtil.singleChildFloat(n);
            });
            PrintUtil.ifChild(this.nodeChildDict[XML_RIGHT], (n) => {
                this._right = PrintUtil.singleChildFloat(n);
            });
        }
    }
    initEdgesWith(top, left, bottom, right) {
        this._top = top;
        this._left = left;
        this._bottom = bottom;
        this._right = right;
    }
    get top() {
        return this._top;
    }
    get left() {
        return this._left;
    }
    get bottom() {
        return this._bottom;
    }
    get right() {
        return this._right;
    }
}
