import { Component } from "./Component";
import { Edges } from "./Edges";
import { CaptureBounds } from "./CaptureBounds";
import { ResizeMode } from "./constants";
import { PrintUtil } from "./PrintUtil";
import { AspectMode, XML_ALLOW_ANNOTATIONS, XML_ALLOW_PICK_OPTIONS, XML_ALLOW_PICKER, XML_ASPECT_MODE, XML_CAP_INSETS, XML_CAPTURE_BOUNDS, XML_RESIZE_MODE, XML_URL } from "./constants";
export class Image extends Component {
    constructor(parentContainer, node) {
        super(parentContainer, node);
        PrintUtil.ifChild(this.nodeChildDict[XML_ALLOW_ANNOTATIONS], (n) => {
            this._allowAnnotations = PrintUtil.singleChildBoolean(n);
        });
        PrintUtil.ifChild(this.nodeChildDict[XML_ALLOW_PICKER], (n) => {
            this._allowPicker = PrintUtil.singleChildBoolean(n);
        });
        PrintUtil.ifChild(this.nodeChildDict[XML_ALLOW_PICK_OPTIONS], (n) => {
            this._allowPickOptions = PrintUtil.singleChildBoolean(n);
        });
        PrintUtil.ifChild(this.nodeChildDict[XML_ASPECT_MODE], (n) => {
            this._aspectMode = PrintUtil.enumValue(n, AspectMode);
        });
        PrintUtil.ifChild(this.nodeChildDict[XML_CAP_INSETS], (n) => {
            this._capInsets = new Edges(n);
        });
        PrintUtil.ifChild(this.nodeChildDict[XML_RESIZE_MODE], (n) => {
            this._resizeMode = PrintUtil.enumValue(n, ResizeMode);
        });
        PrintUtil.ifChild(this.nodeChildDict[XML_URL], (n) => {
            this._urlString = PrintUtil.singleChildText(n);
        });
        PrintUtil.ifChild(this.nodeChildDict[XML_CAPTURE_BOUNDS], (n) => {
            this._captureBounds = new CaptureBounds(n);
        });
    }
    get allowAnnotations() {
        return this._allowAnnotations;
    }
    get allowPicker() {
        return this._allowPicker;
    }
    get allowPickOptions() {
        return this._allowPickOptions;
    }
    get aspectMode() {
        return this._aspectMode;
    }
    get capInsets() {
        return this._capInsets;
    }
    get resizeMode() {
        return this._resizeMode;
    }
    get urlString() {
        return this._urlString;
    }
    get capatureBounds() {
        return this._captureBounds;
    }
}
