import { RichNumUsage } from "./constants";
export class RichNum {
    constructor(_value, _usage = RichNumUsage.Absolute) {
        this._value = _value;
        this._usage = _usage;
    }
    get value() {
        if (!this.isNumber) {
            throw Error("RichNum is not a raw number.");
        }
        return this._value;
    }
    get valueOfPercent() {
        if (!this.isPercentOfParent) {
            throw Error("PercentOfParent requested for wrong usage.");
        }
        return this._value * .01;
    }
    get isNumber() {
        return this._usage == RichNumUsage.Absolute;
    }
    get isFillParent() {
        return this._usage == RichNumUsage.FillParent;
    }
    get isPercentOfParent() {
        return this._usage == RichNumUsage.PercentOfParent;
    }
    resolveWithFill(n) {
        let answer;
        if (this.isNumber) {
            answer = this._value;
        }
        else if (this.isFillParent) {
            answer = n;
        }
        else if (this.isPercentOfParent) {
            answer = this.valueOfPercent * n;
        }
        else {
            throw Error("Unknown RichNum usage on resolveWithFill");
        }
        return answer;
    }
}
RichNum.ZERO = new RichNum(0);
