import { Record } from "./Record";
import { QueryDialog } from "./QueryDialog";
export declare enum QueryMarkerOption {
    None = 0,
    IsEmpty = 1,
    HasMore = 2,
}
export declare class QueryScroller {
    private _dialog;
    private _defaultPageSize;
    private _firstObjectId;
    private _markerOptions;
    private _buffer;
    private _hasMoreBackward;
    private _hasMoreForward;
    private _nextPagePromise;
    private _prevPagePromise;
    private _firstResultOid;
    constructor(_dialog: QueryDialog, _defaultPageSize: number, _firstObjectId: string, _markerOptions?: QueryMarkerOption[]);
    readonly buffer: Record[];
    readonly bufferWithMarkers: Record[];
    readonly dialog: QueryDialog;
    readonly firstObjectId: string;
    readonly hasMoreBackward: boolean;
    readonly hasMoreForward: boolean;
    readonly isComplete: boolean;
    readonly isCompleteAndEmpty: boolean;
    readonly isEmpty: boolean;
    pageBackward(pageSize?: number): Promise<Record[]>;
    pageForward(pageSize?: number): Promise<Record[]>;
    readonly pageSize: number;
    refresh(numRows?: number): Promise<Record[]>;
    trimFirst(n: number): void;
    trimLast(n: number): void;
    private clear();
}
