import { TextAttributes } from "./TextAttributes";
import { Spec } from "./Spec";
import { Container } from "./Container";
import { Binding } from "./Binding";
import { Color } from "./Color";
import { Layout } from "./Layout";
import { Edges } from "./Edges";
export declare abstract class Component extends Spec {
    private _backgroundColor;
    private _binding;
    private _id;
    private _layout;
    private _padding;
    private _parentContainer;
    protected _textAttributes: TextAttributes;
    private _actualHeights;
    private _actualWidths;
    private _actualX;
    private _actualY;
    private _height;
    private _width;
    private _x;
    private _y;
    constructor(parentContainer: Container, node?: Node, overrideLayout?: Layout);
    initComponentWith(overrideLayout?: Layout): void;
    readonly backgroundColor: Color;
    readonly binding: Binding;
    readonly id: string;
    readonly layout: Layout;
    readonly padding: Edges;
    readonly actualHeights: Array<number>;
    readonly actualWidths: Array<number>;
    readonly actualX: number;
    readonly actualY: number;
    readonly height: number;
    readonly parentContainer: Container;
    readonly textAttributes: TextAttributes;
    readonly width: number;
    readonly x: number;
    readonly y: number;
}
